#!/bin/sh

PKG_STR_WIZARD_UPGRADE_TITLE="Læs, før du fortsætter"
PKG_STR_WIZARD_UPGRADE_NOTE="Opgradering til Surveillance Station kræver databasekonvertering og kan således tage lidt tid, afhængigt af antal records i databasen. Vent tålmodigt, og sluk ikke for systemet, eller fjern ikke pakken under processen."
PKG_STR_WIZARD_UPGRADE_VS_60_80_NOTE="Denne version af Surveillance Station er kun kompatibel med VisualStation {0} og senere. Modellerne VisualStation VS60 og VS80 understøttes ikke længere af denne version af Surveillance Station."
PKG_STR_WIZARD_UPGRADE_VS_360HD_NOTE="Efter VS360HD er opgraderet til version 4.0 og senere, erstattes den oprindelige parringsfunktion for Visual Station med den nye loginmekanisme. Du kan logge ind på Surveillance Station direkte fra din Synology VisualStation VS360HD. Derudover understøttes alle netværksvideooptagelsesfunktioner, der styres af Surveillance Station på VS360HD.<br><br>Den aktuelle version af Surveillance Station er kompatibel med både den oprindelige parringsfunktion for VisualStation version 3.0.5 og den nye loginmekanisme for VisualStation version 4.0. Den oprindelige parringsfunktion vil du blive udfaset i kommende opdateringer."
PKG_STR_WIZARD_UPGRADE_PSIA_NOTE="Surveillance Station understøtter ikke længere PSIA fra denne version. Du kan ikke bruge kameraer, som er konfigureret med PSIA på Surveillance Station."
PKG_STR_WIZARD_INCOMPATIBLE_CHECK_LABEL="Jeg forstår kompatibilitetsbegrænsningerne og vil fortsætte med opdateringen."
PKG_STR_WIZARD_UPGRADE_DOOR_LICENSE="Denne version af Surveillance Station vil anvende ny licenspolitik for adgangskontrollere.<br><br>Hver nytilføjet adgangskontroller tælles om en overvågningsenhed og vil bruge en overvågnings"
PKG_STR_WIZARD_DOOR_LICENSE_CHECK_LABEL="Jeg forstår den nye licenspolitik for adgangskontrollere og vil fortsætte med opdateringen."
PKG_STR_WIZARD_DOOR_PRIVILEGE_CHECK_NOTE="Efter opgradering til denne version, vil privilegiestyring for dørkontrollere bliver flyttet til Privilegieprofil på siden Brugere."
PKG_STR_WIZARD_UPGRADE_LABEL="Jeg forstår de ændringer, der er foretaget, og accepterer at fortsætte med opdateringen."
PKG_STR_WIZARD_EDS14_EOL="Surveillance Station 8.2.9 understøtter ikke længere EDS14. Den vil blive fjernet fra CMS efter opdateringen."
PKG_STR_WIZARD_SUGGEST_X64_HOST_NOTE="Da CMS understøtter funktionerne til ansigtsgenkendelse og Deep Video Analytics, anbefaler vi, at du bruger en x64-server som CMS-vært for at sikre en bedre brugeroplevelse."
PKG_STR_WIZARD_FACE_DATABASE_MERGE="Denne opdatering tilføjer understøttelse af ansigtsgenkendelse i en CMS-struktur. Ansigtsdatabaser på DVA-servere vil blive flettet sammen til én. (<a href='http://sy.to/4umx3' target='_blank'>Fletteregler</a>)"
PKG_STR_WIZARD_REMOVE_DEEP_MD="Denne opdatering fjerner Deep Motion Detection. Eksisterende Deep Motion Detection-opgaver vil blive overført til registrering af personer og køretøjer, samtidig med at de oprindelige indstillinger bevares."

# Copyright (c) 2021 Synology Inc. All rights reserved.

SS_PKG_PATH="/var/packages/SurveillanceStation/"
SS_INFO_FILE=${SS_PKG_PATH}"INFO"
SS_SYSTEM_DB_FILE=${SS_PKG_PATH}"target/system.db"
SS_AXISDOOR_DB_FILE=${SS_PKG_PATH}"target/axisacsctrl.db"
SS_AXISDOORLOG_DB_FILE=${SS_PKG_PATH}"target/@surveillance/axisacsevtlog.db"
SS_VER_KEY="version"
SS_SQLITE3_VER="6.3"
SS_THUMBNAIL_ISSUE_BUILD_VER="3312"
SS_THUMBNAIL_FIXED_BUILD_VER="3352"
SS_ADD_DOORLOG_INDEX_BUILD_VER="5372"
VS_MODELS_60_80="'VS60', 'VS80'"
VS_MODELS_360HD="'VS360HD'"
VS_360HD_NEW_LOGIN_MECHANISM_MIN_VERSION="'4.0'"
SS_UNSUPPORT_VENDOR="('PSIA')"
SS_MIN_VS_60_80_VERSION="2.2-1413"
SS_MIN_VS_360_VERSION="3.1-2500"
SS_SQLITE3="${SS_PKG_PATH}target/bin/sqlite3"
DEF_SQLITE3="/usr/syno/bin/sqlite3"
SS_MIN_DOOR_LICENSE_VERSION="8.0.0-5090"
SS_MIN_DOOR_PRIVILEGE_VERSION="8.1.0-5323"
SS_MIN_DVA_SUPPORT_CMS_VERSION="8.2.9-6391"
CMS_DISABLED_FILE=${SS_PKG_PATH}"target/@SSData/AddOns/CMS/disabled"
SS_SETTINGS_CONF_FILE=${SS_PKG_PATH}"etc/settings.conf"
SZK_CMS_MODE="ss_cms_mode"
SZV_CMS_HOST="host"
FN_CHECK_BOX_VALIDATOR="{ var blChecked = arguments[0]; return true === blChecked; }"
DEF_SYNOINFO_CONF="/etc.defaults/synoinfo.conf"

${SS_SQLITE3} --version
if [ $? == 0 ]; then
	SQLITE3_BIN=$SS_SQLITE3
else
	${DEF_SQLITE3} --version
	if [ $? == 0 ]; then
		SQLITE3_BIN=$DEF_SQLITE3
	else
		SQLITE3_BIN="sqlite3"
	fi
fi

UPGRADE_VS_60_80_NOTE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "$(echo $PKG_STR_WIZARD_UPGRADE_VS_60_80_NOTE | sed "s/{0}/${SS_MIN_VS_60_80_VERSION}/g")",
		"subitems": [{
			"desc": "${PKG_STR_WIZARD_INCOMPATIBLE_CHECK_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			}
		}]
	}]
}
EOF`

UPGRADE_VS_360_NOTE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"items": [{
		"desc": "$PKG_STR_WIZARD_UPGRADE_VS_360HD_NOTE"
	}]
}
EOF`

UPGRADE_PSIA_NOTE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_UPGRADE_PSIA_NOTE}",
		"subitems": [{
			"desc": "${PKG_STR_WIZARD_INCOMPATIBLE_CHECK_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			}
		}]
	}]
}
EOF`

UPGRADE_DB_NOTE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"desc": "${PKG_STR_WIZARD_UPGRADE_NOTE}"
	}]
}
EOF`

UPGRADE_DOOR_LICENSE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "$PKG_STR_WIZARD_UPGRADE_DOOR_LICENSE",
		"subitems": [{
			"desc": "${PKG_STR_WIZARD_DOOR_LICENSE_CHECK_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			}
		}]
	}]
}
EOF`

UPGRADE_DOOR_PRIVILEGE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_DOOR_PRIVILEGE_CHECK_NOTE}",
		"subitems": [{
			"desc": "${PKG_STR_WIZARD_UPGRADE_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			}
		}]
	}]
}
EOF`

EDS14_EOL_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_EDS14_EOL}",
		"subitems": [{
			"key": "ui_confirmed_eds14_eol",
			"desc": "${PKG_STR_WIZARD_UPGRADE_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			},
			"defaultValue": false
		}]
	}]
}
EOF`

SUGGEST_X64_HOST_NOTE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_SUGGEST_X64_HOST_NOTE}",
		"subitems": [{
			"key": "ui_confirmed_suggest_x64_host",
			"defaultValue": true,
			"hidden": true
		}]
	}]
}
EOF`

FACE_DATABASE_MERGE_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_FACE_DATABASE_MERGE}",
		"subitems": [{
			"key": "ui_confirmed_face_database_merge",
			"desc": "${PKG_STR_WIZARD_UPGRADE_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			},
			"defaultValue": false
		}]
	}]
}
EOF`

REMOVE_DEEP_MD_PAGE=`/bin/cat<<EOF
{
	"step_title": "${PKG_STR_WIZARD_UPGRADE_TITLE}",
	"invalid_next_disabled": true,
	"items": [{
		"type": "multiselect",
		"desc": "${PKG_STR_WIZARD_REMOVE_DEEP_MD}",
		"subitems": [{
			"key": "ui_confirmed_remove_deep_md",
			"desc": "${PKG_STR_WIZARD_UPGRADE_LABEL}",
			"validator": {
				"fn": "$FN_CHECK_BOX_VALIDATOR"
			},
			"defaultValue": false
		}]
	}]
}
EOF`

Sqlite3Exec()
{
	$SQLITE3_BIN -init /dev/null -cmd ".timeout 300000" "$@"
}

IsUpgradeToSqlite3()
{
	local PreSSVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}" | cut -d '-' -f 1)

	if [ ${SS_SQLITE3_VER} \> ${PreSSVer} ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsUpgradeToDoorLicense()
{
	local TargetSSVer=$(echo ${SS_MIN_DOOR_LICENSE_VERSION} | sed 's/\.//g' | sed 's/-//g')
	local CurrentSSVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}")

	CurrentSSVer=$(echo ${CurrentSSVer} | sed 's/\.//g' | sed 's/-//g')

	if [ "${TargetSSVer}" -gt "${CurrentSSVer}" ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsUpgradeThumbnailToFile()
{
	local PreSSBuildVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}" | cut -d '-' -f 2)

	if [ ${SS_THUMBNAIL_ISSUE_BUILD_VER} -le ${PreSSBuildVer} ] && [ ${SS_THUMBNAIL_FIXED_BUILD_VER} -gt ${PreSSBuildVer} ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsUpgradeToDoorPrivilege()
{
	local TargetSSVer=$(echo ${SS_MIN_DOOR_PRIVILEGE_VERSION} | sed 's/\.//g' | sed 's/-//g')
	local CurrentSSVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}")

	CurrentSSVer=$(echo ${CurrentSSVer} | sed 's/\.//g' | sed 's/-//g')

	if [ "${TargetSSVer}" -ge "${CurrentSSVer}" ]; then
		echo "true"
	else
		echo "false"
	fi
}

HasVS()
{
	local Models="$1"
	local MinVersion="$2"
	local SqlCmd="SELECT COUNT(*) FROM visualstation WHERE platform IN ($Models)"

	if [ -n "$MinVersion" ]; then
		SqlCmd="SELECT COUNT(*) FROM visualstation WHERE platform IN ($Models) AND version < $MinVersion"
	else
		SqlCmd="SELECT COUNT(*) FROM visualstation WHERE platform IN ($Models)"
	fi

	CheckSystemDBItemExist "${SqlCmd}"
}

HasPsiaCam()
{
	local SqlCmd="SELECT COUNT(*) FROM camera WHERE vendor IN ${SS_UNSUPPORT_VENDOR}"

	CheckSystemDBItemExist "${SqlCmd}"
}

HasDoor()
{
	local DoorCount=$(sqlite3 $SS_AXISDOOR_DB_FILE "SELECT COUNT (id) FROM axisacsctrler where id IS NOT NULL")

	if [ $DoorCount -gt 0 ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsCmsHostHasEds14Slave()
{
	local CmsHost=$(get_key_value "${SS_SETTINGS_CONF_FILE}" "${SZK_CMS_MODE}")
	local Eds14RecCnt=$(sqlite3 ${SS_SYSTEM_DB_FILE} "SELECT count(id) FROM slaveds WHERE ds_model = 'EDS14'")

	if [ ! -f ${CMS_DISABLED_FILE} ] && [ ${SZV_CMS_HOST} == ${CmsHost} ] && [ ${Eds14RecCnt} -gt 0 ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsCmsHostHasDvaSlave()
{
	local CmsHost=$(get_key_value "${SS_SETTINGS_CONF_FILE}" "${SZK_CMS_MODE}")
	local DvaRecCnt=$(Sqlite3Exec "${SS_SYSTEM_DB_FILE}" "SELECT count(id) FROM slaveds WHERE ds_model like '%DVA%'")

	if [ ! -f ${CMS_DISABLED_FILE} ] && [ ${SZV_CMS_HOST} == ${CmsHost} ] && [ ${DvaRecCnt} -gt 0 ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsX64Arch()
{
	local Arch=$(/bin/get_key_value "${SS_INFO_FILE}" "arch")

	if [ "${Arch}" == "x86_64" ]; then
		echo "true"
	else
		echo "false"
	fi
}

IsSupportSynoface()
{
	local UniqueName=$(/bin/get_key_value "${DEF_SYNOINFO_CONF}" "unique")
	if [[ "${UniqueName}" == "synology_denverton_dva3219" || "${UniqueName}" == "synology_denverton_dva3221" ]]; then
		echo "true"
	else
		echo "false"
	fi
}

IsMergeFaceDatabase()
{
	if [ -f ${CMS_DISABLED_FILE} ]; then
		echo "false"
		return 0
	fi

	local CmsMode=$(get_key_value "${SS_SETTINGS_CONF_FILE}" "${SZK_CMS_MODE}")
	local DvaRecCnt=$(Sqlite3Exec "${SS_SYSTEM_DB_FILE}" "SELECT count(id) FROM slaveds WHERE ds_model like '%DVA%'")

	if [ "false" == $(IsSupportSynoface) ]; then
		if [ ${SZV_CMS_HOST} != ${CmsMode} ] || [ ${DvaRecCnt} -le 0 ]; then
			echo "false"
			return 0
		fi
	else
		if [ ${SZV_CMS_HOST} == ${CmsMode} ] && [ ${DvaRecCnt} -le 0 ]; then
			echo "false"
			return 0
		fi
	fi

	echo "true"
}

IsHasDeepMD()
{
	local DeepMDCnt=$(Sqlite3Exec "${SS_SYSTEM_DB_FILE}" "SELECT count(id) FROM iva_setting WHERE analyze_type = 1")

	if [ "false" == $(IsSupportSynoface) ] || [ ${DeepMDCnt} -le 0 ]; then
		echo "false"
	else
		echo "true"
	fi
}

IsBeforeMinDvaSupportCmsVersion()
{
	local TargetSSVer=$(echo ${SS_MIN_DVA_SUPPORT_CMS_VERSION} | sed 's/\.//g' | sed 's/-//g')
	local CurrentSSVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}")

	CurrentSSVer=$(echo ${CurrentSSVer} | sed 's/\.//g' | sed 's/-//g')

	if [ "${TargetSSVer}" -ge "${CurrentSSVer}" ]; then
		echo "true"
	else
		echo "false"
	fi
}

HasLargeDoorLog()
{
	local PreSSBuildVer=$(/bin/get_key_value "${SS_INFO_FILE}" "${SS_VER_KEY}" | cut -d '-' -f 2)
	local DoorLogCount=$(sqlite3 $SS_AXISDOORLOG_DB_FILE "SELECT COUNT (*) FROM axisacsevtlog")

	if [ ${SS_ADD_DOORLOG_INDEX_BUILD_VER} -gt ${PreSSBuildVer} ] && [ ${DoorLogCount} -gt 60000 ]; then
		echo "true"
	else
		echo "false"
	fi
}

CheckSystemDBItemExist()
{
	local SqlCmd="$1"
	local Cnt=$(Sqlite3Exec $SS_SYSTEM_DB_FILE "$SqlCmd")

	if [ -z "${Cnt}" ]; then
		if [ -f /usr/syno/pgsql/bin/psql ]; then
			Cnt=$(/usr/syno/pgsql/bin/psql -A -t -U postgres surveillance -c "${SqlCmd}")
		else
			Cnt=0
		fi
	fi

	if [ ${Cnt} -gt 0 ]; then
		echo "true"
	else
		echo "false"
	fi
}

GetUpgradeNotePages()
{
	local Pages=""

	if [ "true" == $(HasPsiaCam) ]; then
		Pages="${UPGRADE_PSIA_NOTE_PAGE}"
	fi

	if [ "true" == $(HasVS "$VS_MODELS_60_80") ]; then
		[ -z "$Pages" ] && Pages="${UPGRADE_VS_60_80_NOTE_PAGE}" \
						|| Pages="${Pages},${UPGRADE_VS_60_80_NOTE_PAGE}"
	fi

	if [ "true" == $(HasVS "$VS_MODELS_360HD" "$VS_360HD_NEW_LOGIN_MECHANISM_MIN_VERSION") ]; then
		[ -z "$Pages" ] && Pages="${UPGRADE_VS_360_NOTE_PAGE}" \
				        || Pages="${Pages},${UPGRADE_VS_360_NOTE_PAGE}"
	fi

	if [ "true" == $(IsUpgradeToSqlite3) ] || [ "true" == $(IsUpgradeThumbnailToFile) ] || [ "true" == $(HasLargeDoorLog) ]; then
		[ -z "$Pages" ] && Pages="${UPGRADE_DB_NOTE_PAGE}" \
				        || Pages="${Pages},${UPGRADE_DB_NOTE_PAGE}"
	fi

	if [ "true" == $(IsUpgradeToDoorLicense) ] && [ "true" == $(HasDoor) ]; then
		[ -z "$Pages" ] && Pages="${UPGRADE_DOOR_LICENSE_PAGE}" \
				        || Pages="${Pages},${UPGRADE_DOOR_LICENSE_PAGE}"
	fi

	if [ "true" == $(IsUpgradeToDoorPrivilege) ] && [ "true" == $(HasDoor) ]; then
		[ -z "$Pages" ] && Pages="${UPGRADE_DOOR_PRIVILEGE_PAGE}" \
				        || Pages="${Pages},${UPGRADE_DOOR_PRIVILEGE_PAGE}"
	fi

	if [ "true" == $(IsCmsHostHasEds14Slave) ]; then
		[ -z "$Pages" ] && Pages="${EDS14_EOL_PAGE}" \
					|| Pages="${Pages},${EDS14_EOL_PAGE}"
	fi

	if [ "true" == $(IsCmsHostHasDvaSlave) ] && [ "false" == $(IsX64Arch) ] && [ "true" == $(IsBeforeMinDvaSupportCmsVersion) ]; then
		[ -z "$Pages" ] && Pages="${SUGGEST_X64_HOST_NOTE_PAGE}" \
					|| Pages="${Pages},${SUGGEST_X64_HOST_NOTE_PAGE}"
	fi

	if [ "true" == $(IsHasDeepMD) ] && [ "true" == $(IsBeforeMinDvaSupportCmsVersion) ]; then
		[ -z "$Pages" ] && Pages="${REMOVE_DEEP_MD_PAGE}" \
					|| Pages="${Pages},${REMOVE_DEEP_MD_PAGE}"
	fi

	if [ "true" == $(IsMergeFaceDatabase) ] && [ "true" == $(IsBeforeMinDvaSupportCmsVersion) ]; then
		[ -z "$Pages" ] && Pages="${FACE_DATABASE_MERGE_PAGE}" \
					|| Pages="${Pages},${FACE_DATABASE_MERGE_PAGE}"
	fi

	echo "[$Pages]"
}

main()
{
	local UpgradeNotePages="$(GetUpgradeNotePages)"

	echo "$UpgradeNotePages" > $SYNOPKG_TEMP_LOGFILE

	exit 0
}

main "$@"
