CREATE TABLE IF NOT EXISTS axisacsctrler (
	id					integer PRIMARY KEY AUTOINCREMENT,
	port				integer DEFAULT 0,
	grp_id				integer DEFAULT 0,
	update_time			integer DEFAULT 0,
	status				integer DEFAULT 0,
	evt_tmstmp			integer DEFAULT 0,
	evt_row_id			integer DEFAULT 0,
	prev_evt_row_id		integer DEFAULT 0,
	alarm_tmstmp		integer DEFAULT 0,
	alarm_row_id		integer DEFAULT 0,
	notified_row_id		integer DEFAULT 0,
	name				varchar(256) DEFAULT '',
	host				varchar(256) DEFAULT '',
	model				varchar(128) DEFAULT '',
	username			varchar(128) DEFAULT '',
	password			varchar(128) DEFAULT '',
	uuid				varchar(64) DEFAULT '',
	mac_addr			varchar(64) DEFAULT '',
	time_server			text DEFAULT '',
	time_zone			text DEFAULT '',
	log_evt				text DEFAULT '11111111111111111111111111111111111111',
	log_alarm			text DEFAULT '00000000000000000000000000000000000000',
	enable				boolean DEFAULT '0',
	dirty				boolean DEFAULT '0',
	need_to_retrieve	integer DEFAULT 0,
	notifyschedule		text DEFAULT '7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF',
	license				varchar(128) DEFAULT ''
);
CREATE INDEX IF NOT EXISTS axisacsctrler_update_time_idx ON axisacsctrler (update_time);
CREATE TRIGGER IF NOT EXISTS axisacsctrler_auto_update AFTER UPDATE ON axisacsctrler BEGIN UPDATE OR IGNORE axisacsctrler SET update_time = (SELECT MAX(update_time) FROM axisacsctrler) + 1 WHERE id = new.id; END;

CREATE TABLE IF NOT EXISTS axisdoor (
	id							integer PRIMARY KEY AUTOINCREMENT,
	ctrler_id					integer DEFAULT 0,
	cam_id						integer DEFAULT 0,
	cam_ds_id					integer DEFAULT 0,
	status						integer DEFAULT 0,
	token						varchar(256) DEFAULT '',
	name						varchar(256) DEFAULT '',
	enable_cam					boolean DEFAULT '0',
	notifyschedule				text DEFAULT '7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF,7FF',
	enter_reader_custom_auth	VARCHAR(128) DEFAULT '',
	exit_reader_custom_auth		VARCHAR(128) DEFAULT '',
	access_time			integer DEFAULT 7,
	long_access_time	integer DEFAULT 30
);

CREATE TABLE IF NOT EXISTS axisidpoint (
	id				integer PRIMARY KEY AUTOINCREMENT,
	ctrler_id		integer DEFAULT 0,
	door_id			integer DEFAULT 0,
	type			integer DEFAULT 0,
	direction		integer DEFAULT 0,
	token			varchar(256) DEFAULT '',
	acspoint_token	varchar(256) DEFAULT '',
	door_token		varchar(256) DEFAULT '',
	min_pin_length	integer DEFAULT 4,
	max_pin_length	integer DEFAULT 4,
	enable_pin_range	boolean DEFAULT '0'
);

CREATE TABLE IF NOT EXISTS axiscardholder (
	id					integer PRIMARY KEY AUTOINCREMENT,
	ctrler_id			integer DEFAULT 0,
	grp_id				integer DEFAULT 0,
	valid_from			integer DEFAULT 0,
	valid_until			integer DEFAULT 0,
	last_access			integer DEFAULT 0,
	photo_width			integer DEFAULT 0,
	photo_height		integer DEFAULT 0,
	photo_tmstmp		integer DEFAULT 0,
	card_token			varchar(256) DEFAULT '',
	user_token			varchar(256) DEFAULT '',
	first_name			varchar(256) DEFAULT '',
	last_name			varchar(256) DEFAULT '',
	photo_name			varchar(256) DEFAULT '',
	facility_code		varchar(64) DEFAULT '',
	card_num			varchar(64) DEFAULT '',
	card_raw			varchar(64) DEFAULT '',
	pin					varchar(16) DEFAULT '',
	description			varchar(128) DEFAULT '',
	employ_no			varchar(128) DEFAULT '',
	department			varchar(64) DEFAULT '',
	title				varchar(64) DEFAULT '',
	extension			varchar(16) DEFAULT '',
	email				varchar(256) DEFAULT '',
	token_info			text DEFAULT '',
	enable_valid_from	boolean DEFAULT '0',
	enable_valid_until	boolean DEFAULT '0',
	blocked				boolean DEFAULT '0',
	enable_long_access_time	boolean DEFAULT '0',
	acsrule_ids			text DEFAULT ''
);
CREATE INDEX IF NOT EXISTS cardholder_categ_idx ON axiscardholder(ctrler_id, blocked, enable_valid_until, valid_until);

CREATE TABLE IF NOT EXISTS axisacssch (
	id					integer PRIMARY KEY AUTOINCREMENT,
	ctrler_id			integer DEFAULT 0,
	grp_id				integer DEFAULT 0,
	type				integer DEFAULT 0,
	token				varchar(256) DEFAULT '',
	name				varchar(256) DEFAULT '',
	enable_start_time	boolean DEFAULT '1',
	enable_end_time		boolean DEFAULT '1'
);

CREATE TABLE IF NOT EXISTS axisevtsch (
	ctrler_id			integer DEFAULT 0,
	token				varchar(256) DEFAULT '',
	name				varchar(256) DEFAULT ''
);

CREATE TABLE IF NOT EXISTS axisacsprivilege (
	id					varchar(32) PRIMARY KEY,
	uid					integer DEFAULT 0,
	door_id				integer DEFAULT 0,
	authorized			boolean DEFAULT '0',
	manual_lock			boolean DEFAULT '0',
	operation_priv		integer DEFAULT 0
);

CREATE TABLE IF NOT EXISTS axisacsschevt (
	id					integer PRIMARY KEY AUTOINCREMENT,
	sch_id				varchar(256) DEFAULT '',
	name				varchar(256) DEFAULT '',
	type				integer DEFAULT 0,
	start_time			integer DEFAULT 0,
	end_time			integer DEFAULT 0,
	rec_day				integer DEFAULT 0,
	until_day			integer DEFAULT 0
);

CREATE TABLE IF NOT EXISTS axisacsrule (
	id					integer PRIMARY KEY AUTOINCREMENT,
	name				varchar(256) DEFAULT '',
	description			varchar(256) DEFAULT '',
	acs_prf_token		varchar(256) DEFAULT '',
	sch_ids				varchar(256) DEFAULT '',
	door_ids			varchar(256) DEFAULT ''
);

CREATE TABLE IF NOT EXISTS axisauthprofile (
	id					integer PRIMARY KEY AUTOINCREMENT,
	door_id				integer DEFAULT 0,
	type				integer DEFAULT 0,
	direction			integer DEFAULT 0,
	token				varchar(256) DEFAULT '',
	schedule_ids		varchar(256) DEFAULT ''
);
