from openpyxl import Workbook
import sys
import os.path
import time
import datetime

seperator = "|"
title = ''
firstColumn = []

inputFileName = sys.argv[1]
outputDir = sys.argv[2]
_, int_ext = os.path.splitext(inputFileName)
MAX_LINE_TO_READ = 5000
INDEX_TIME_COLUMN = 1

def WriteToXlsx(lines):
    fileNamePrefix = ''
    fileName = ''
    wb = Workbook()
    ws1 = wb.active
    ws1.title = title
    ws1.append(firstColumn)
    rowNum = 2

    columnNum = len(lines[0])
    for logData in lines:
        for col in range(columnNum):
            ws1.cell(column=col+1, row=rowNum, value=logData[col])

        rowNum += 1

    '''
    translate from: 2019/12/10 15:15:07 -----> 20191210-1515
    replace: '/' - > ''
    replace: ':' -> ''
    replace: ' ' -> '-'
    remove second info: [:-2]
    '''
    if 'surlog' in outputDir:
        fileNamePrefix = 'surlog'
    elif 'sureventlog' in outputDir:
        fileNamePrefix = 'sureventlog'

    fileBeginDatetimeStr = str(lines[0][INDEX_TIME_COLUMN]).replace('/', '').replace(':', '').replace(' ', '-')[:-2]
    fileEndDateTimeStr = str(lines[-1][INDEX_TIME_COLUMN]).replace('/', '').replace(':', '').replace(' ', '-')[:-2]

    # only 1 record in the list
    if fileBeginDatetimeStr == fileEndDateTimeStr:
        fileName = '{0}{1}_{2}.xlsx'.format(outputDir, fileNamePrefix, fileBeginDatetimeStr)
    else:
        fileName = '{0}{1}_{2}_{3}.xlsx'.format(outputDir, fileNamePrefix, fileBeginDatetimeStr, fileEndDateTimeStr)

    # print 'Filename is ', fileName

    ws1.column_dimensions["A"].width = 20.0
    ws1.column_dimensions["B"].width = 20.0
    ws1.column_dimensions["C"].width = 20.0
    ws1.column_dimensions["D"].width = 20.0
    ws1.column_dimensions["E"].width = 20.0

    wb.save(filename = fileName)

if not int_ext in ('.txt') or not os.path.isdir(outputDir):
    sys.exit(1)

with open(inputFileName, "r") as logFile:
    # first line: title
    if sys.version_info >= (3, 0):
        title = logFile.readline().strip("\n")
    else:
        title = logFile.readline().strip("\n").decode("utf-8")
    # second line: column
    firstColumn = logFile.readline().strip("\n").split(seperator)

    lines = []

    # append '/' in the dir name
    if '/' != outputDir[-1]:
        outputDir += '/'

    while True:
        line = logFile.readline()

        if not line:
            if 0 != len(lines):
                WriteToXlsx(lines)
            break

        # translate timestamp to datetime in string
        logData = line.strip("\n").split(seperator)
        logDataTimestamp = logData[INDEX_TIME_COLUMN]
        logDataDateTime = datetime.datetime.utcfromtimestamp(float(logDataTimestamp))
        logData[INDEX_TIME_COLUMN] = logDataDateTime.strftime('%Y/%m/%d %H:%M:%S')

        lines.append(logData)

        if len(lines) >= MAX_LINE_TO_READ:
            WriteToXlsx(lines)
            lines[:] = []
