#!/bin/sh
# Copyright (c) 2020 Synology Inc. All rights reserved.
# (Before DSM7 beta -> surveillance_share_encryption_action.sh)
# Check https://synowiki.synology.com/index.php/SYNOShareMountAction

ORIGIN_SHARE_NAME=$SHARE_NAME
ORIGIN_SHARE_PATH=$SHARE_PATH

HOOK_SCRP=/var/packages/SurveillanceStation/target/scripts/ShareHookCommon.sh
. $HOOK_SCRP

PrintArgs()
{
	local Msg="$1"

	SSDebugLog "[$Msg] NAME: $ORIGIN_SHARE_NAME => $SHARE_NAME"
	SSDebugLog "[$Msg] PATH: $ORIGIN_SHARE_PATH => $SHARE_PATH"
	SSDebugLog "[$Msg] SHARE_TYPE $SHARE_TYPE"
	SSDebugLog "[$Msg] MOUNT_ACTION $MOUNT_ACTION"
	SSDebugLog "[$Msg] RESULT: $RESULT"
}

SSShareEncActBegin()
{
	if [ "encryption" == "$SHARE_TYPE" -a "unmount" == "$MOUNT_ACTION" ]; then
		SharePreSetHook false true
	fi
}

SSShareEncActEnd()
{
	if [ "encryption" == "$SHARE_TYPE" -a "mount" == "$MOUNT_ACTION" ]; then
		SharePostSetHook true
	fi
}

main()
{
	PackageInfoGet;

	case $1 in
		--sdk-mod-ver)
			echo "2.0"
		;;
		--name)
			echo ${SURVEILLANCE_PKG_NAME};
		;;
		--pkg-ver)
			echo ${SURVEILLANCE_PKG_VERSION};
		;;
		--vendor)
			echo ${SURVEILLANCE_PKG_VENDOR};
		;;
		--pre)
			#PrintArgs "--pre"
			SSShareEncActBegin
		;;
		--post)
			#PrintArgs "--post"
			SSShareEncActEnd;
		;;
		*)
			echo "Usage: $0 --sdk-mod-ver|--name|--pkg-ver|--vendor|--pre|--post"
		;;
	esac
}

main "$@"
