BEGIN;

CREATE TABLE IF NOT EXISTS eventlog_cnt (
	dsid	integer PRIMARY KEY,
	cnt	integer DEFAULT 0
);

CREATE TRIGGER IF NOT EXISTS eventlog_auto_update_insert AFTER INSERT ON eventlog BEGIN
	UPDATE eventlog_cnt SET cnt = (cnt+1) WHERE dsid = NEW.dsid;
END;

CREATE TRIGGER IF NOT EXISTS eventlog_auto_update_delete AFTER DELETE ON eventlog BEGIN
	UPDATE eventlog_cnt SET cnt = (cnt-1) WHERE dsid = OLD.dsid;
END;

COMMIT;
