BEGIN;

CREATE TABLE IF NOT EXISTS face_to_recording (
	id						integer PRIMARY KEY AUTOINCREMENT,
	captured_face_id		integer UNIQUE,
	task_id					integer,
	recording_id			integer DEFAULT 0,
	locked					boolean DEFAULT '0',
	filesize				integer
);
CREATE INDEX IF NOT EXISTS face_to_recording_captured_face_id_idx ON face_to_recording(captured_face_id);
CREATE INDEX IF NOT EXISTS face_to_recording_recording_id_idx ON face_to_recording(recording_id);
CREATE INDEX IF NOT EXISTS face_to_recording_locked_idx ON face_to_recording(locked);
CREATE INDEX IF NOT EXISTS face_to_recording_task_id_idx ON face_to_recording(task_id);

COMMIT;
