#!/usr/bin/env bash

##### Please change the following settings first #####

# Target Info
TARGET_IP="10.17.48.159"
TARGET_USER_NAME="admin"
TARGET_PASSWD="123123"

# RTSP Server Info
RTSP_IP="10.17.199.34"
RTSP_USER_NAME="admin"
RTSP_PASSWD="synology"

# Viewer Info
VIEWER_IP="10.17.199.34"
VIEWER_USER_NAME="admin"
VIEWER_PASSWD="synology"

# Local info
LOCAL_USER_NAME="wei"
VIDEO_PATH="/synosrc/videos"

# Test settings
MAX_CAM_NUM=24
MONITOR_PERIOD_HR=24 # total hours of stressing

# DVA related settings
IS_MONITOR_GPU=false
DVA_TASK_NUM=0
DVA_TASK_TYPE=8
FACE_TASK_NUM=4

######################################################

WORKING_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

substitude_conf()
{
	INPUT_FILE=$1
	OUTPUT_FILE=$2

	sed "
	s|@@TARGET_IP@@|${TARGET_IP}|g;
	s|@@TARGET_USER_NAME@@|${TARGET_USER_NAME}|g;
	s|@@TARGET_PASSWD@@|${TARGET_PASSWD}|g;
	s|@@RTSP_IP@@|${RTSP_IP}|g;
	s|@@RTSP_USER_NAME@@|${RTSP_USER_NAME}|g;
	s|@@RTSP_PASSWD@@|${RTSP_PASSWD}|g;
	s|@@VIEWER_IP@@|${VIEWER_IP}|g;
	s|@@VIEWER_USER_NAME@@|${VIEWER_USER_NAME}|g;
	s|@@VIEWER_PASSWD@@|${VIEWER_PASSWD}|g;
	s|@@LOCAL_USER_NAME@@|${LOCAL_USER_NAME}|g;
	s|@@CURR_DIRECTORY_PATH@@|${WORKING_DIR}|g;
	s|@@VIDEO_PATH@@|${VIDEO_PATH}|g;
	s|@@MAX_CAM_NUM@@|${MAX_CAM_NUM}|g;
	s|@@MONITOR_PERIOD_HR@@|${MONITOR_PERIOD_HR}|g;
	s|@@IS_MONITOR_GPU@@|${IS_MONITOR_GPU}|g;
	s|@@DVA_TASK_NUM@@|${DVA_TASK_NUM}|g;
	s|@@DVA_TASK_TYPE@@|${DVA_TASK_TYPE}|g;
	s|@@FACE_TASK_NUM@@|${FACE_TASK_NUM}|g;
	" "${INPUT_FILE}" > "${OUTPUT_FILE}"
}

substitude_conf "${WORKING_DIR}/conf_template/rtspConf.json.template" "rtspConf.json"
substitude_conf "${WORKING_DIR}/conf_template/conf.json.template" "conf.json"
